VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IPythonScript"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'this is just an interface declaration, so we can generically share the interface between
'our CPython class, and the eventual debugger user control.
'
'This is necessary because of callbacks in a global module needs to know where to route callback info
'through its ActiveObject member. Ownership is taken on CPython.Initilize

'There are other more complicated ways to do this..but I will stay within normal vb design parameters.
'
'we can only have one CPython script or usercontrol instance active at a time (python limitation too)
'
'Misc note: python threading is not true threading. Its parallel processing, only one
'thread executes at a time and the python runtime switches between them to share time.

Public Enum cb_type
    cb_output = 0
    cb_error = 1
    cb_Refresh = 2
    cb_StringReturn = 3
    cb_devMsg = 4
End Enum

Public Enum dcb_type
    dcb_dbg = 0
    dcb_callstack = 1
    dcb_globals = 2
    dcb_locals = 3
    dcb_args = 4
End Enum

Sub vbOut(mType As cb_type, msg As String)

End Sub

Property Get SharedObjects() As Collection

End Property

Property Get isRunning() As Boolean

End Property

Function DebugHandler(ByVal t As dcb_type, msg As String) As Long

End Function

