VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Python Embedding Example"
   ClientHeight    =   11295
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   14685
   LinkTopic       =   "Form1"
   ScaleHeight     =   11295
   ScaleWidth      =   14685
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command2 
      Caption         =   "FreePy4vb"
      Height          =   375
      Left            =   13455
      TabIndex        =   7
      Top             =   8505
      Width           =   1050
   End
   Begin VB.TextBox txtOut 
      Height          =   2625
      Left            =   720
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      Top             =   8460
      Width           =   7800
   End
   Begin VB.TextBox txtData 
      Height          =   330
      Left            =   11295
      TabIndex        =   4
      Text            =   "test string from vb!"
      Top             =   8505
      Width           =   2040
   End
   Begin VB.ListBox List1 
      Height          =   2010
      Left            =   8955
      TabIndex        =   2
      Top             =   9000
      Width           =   5190
   End
   Begin VB.CommandButton cmdExecPy 
      Caption         =   "Test COM"
      Enabled         =   0   'False
      Height          =   375
      Left            =   8640
      TabIndex        =   1
      Top             =   8505
      Width           =   1275
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   8160
      Left            =   45
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "Form1.frx":0000
      Top             =   90
      Width           =   14415
   End
   Begin VB.Label Label2 
      Caption         =   "Output"
      Height          =   195
      Left            =   135
      TabIndex        =   5
      Top             =   8550
      Width           =   555
   End
   Begin VB.Label Label1 
      Caption         =   "TxtData"
      Height          =   240
      Left            =   10530
      TabIndex        =   3
      Top             =   8550
      Width           =   645
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim last As String

Public col As New Collection

Property Get getCol()
    Set getCol = col
End Property


'make sure to copy the pycom folder to your python /lib/site-packages directory

Sub AddObject(name As String, o As Object) 'not case sensitive
    On Error Resume Next
    SharedObjects.Add o, LCase(name)
End Sub

Function lst() As Object
    Set lst = List1
End Function



Private Sub cmdExecPy_Click()
    Dim rv As Long, pFunc As Long, pArgs As Long, pVal As Long, oGVar1
    Dim args() As String
    
    'On Error Resume Next
    
    AddObject "form1", Me
    AddObject "app", App
    
    WriteFile last, Text1.Text
    
    List1.Clear
    txtOut = Empty
        
    rv = PyOp(op_Init)
    la "Init = " & rv
    
    rv = PyOp(op_LoadCode, , Text1.Text)
        
    'if we call this, it only works first run..never finalize for COM to keep to working..
    rv = PyOp(op_Final)
    la "Finalize = " & rv
    
    rv = GetModuleHandle("pythoncom311.dll")
    If rv <> 0 Then
        la "pythoncom was found loaded?"
    End If
    
    Set SharedObjects = New Collection
    
End Sub

Private Sub Command1_Click()
'7C8D0000       47000    C:\Users\dzzie\Desktop\py4vb\py4vb.dll
'78C40000      4DE000    C:\Py311\python311.dll
'02220000        F000    C:\Py311\python3.DLL
'79A30000        7000    C:\Py311\Lib\site-packages\win32\_win32sysloader.pyd
'79A40000       1E000    C:\Py311\Lib\site-packages\pywin32_system32\pywintypes311.dll
'79A60000       8F000    C:\Py311\Lib\site-packages\pywin32_system32\pythoncom311.dll
'79AF0000       1D000    C:\Py311\Lib\site-packages\win32\win32api.pyd
    Dim h As Long, tmp(), t
    
    'this works to reset the system between runs..
    tmp = Array("_win32sysloader.pyd", "win32api.pyd", "pywintypes311.dll", "pythoncom311.dll")
    For Each t In tmp
        h = GetModuleHandle(t)
        FreeLibrary h
    Next
    
End Sub

'we might need this to recompile..
Private Sub Command2_Click()
    Dim i As Long, h As Long
    For i = 0 To 10
        h = GetModuleHandle("py4vb.dll")
        If h = 0 Then Exit Sub
        FreeLibrary h
    Next
End Sub

Private Sub Form_Load()

    Dim dll As String, pyDll As String, hPy As Long
    
    col.Add "test"
    col.Add 2
    col.Add Me
    
    dll = App.path & "\..\py4vb.dll"
    last = App.path & "\com_test.py"
    
    If FileExists(last) Then Text1 = ReadFile(last)
    
    If Not FileExists(dll) Then dll = App.path & "\py4vb.dll"
    
    If FileExists(dll) Then
        la "Found: " & dll
    Else
        la "Failed to find py4vb.dll"
        Exit Sub
    End If
    
    'if you want to manually set a path to your 32 bit python install do it here (dont move the python311.dll)
    'pyDll = "c:\py311\python311.dll"
    
    If Len(pyDll) > 0 Then 'manually set
        If is32Bit(pyDll) Then
            la "manually set python311.dll confirmed 32 bit"
            'better preload it since it may not be in path..(will it find the imports? dunno better to be in path)
            'we could also use SetDllDirectory safer?
            hPy = LoadLibrary(pyDll)
            If hPy = 0 Then
                la "Failed to LoadLibrary(python311.dll)"
                Exit Sub
            Else
                la "Manually preloaded python311.dll ok: " & Hex(hPy)
            End If
        Else
            la "python311.dll is NOT 32 bit"
            Exit Sub
        End If
    Else
        If Not scanPathFor32bitPythonInstall(pyDll) Then
            la "Could not find 32bit python311.dll in path? probably wont work..."
        Else
            la "32 bit python found in path: " & pyDll
        End If
    End If
    
    
    If Not LoadPyLib(dll) Then
        la "Failed to Load py lib"
        Exit Sub
    Else
        la "Python loaded and ready"
    End If
    
    cmdExecPy.Enabled = True
    
    'm_lCookie = PutObject(Me, "PyComTest.Form1")
    'la "Put object handle:= " & Hex(m_lCookie)
    
End Sub
 
Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    Dim h As Long
    WriteFile last, Text1.Text
    'FreeLibrary hPyLib
    h = GetModuleHandle("py4vb.dll")
    If h <> 0 Then FreeLibrary h
    'RevokeObject m_lCookie
End Sub

Function la(x)
    On Error Resume Next
    List1.AddItem x
    List1.ListIndex = List1.ListCount - 1
End Function
