VERSION 5.00
Object = "{14B6042D-B1AC-407E-AE2D-BFDC75533E8B}#2.0#0"; "py4vb.ocx"
Begin VB.Form Form1 
   Caption         =   "ucPyDbgHost"
   ClientHeight    =   11025
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   13140
   LinkTopic       =   "Form1"
   ScaleHeight     =   11025
   ScaleWidth      =   13140
   StartUpPosition =   2  'CenterScreen
   Begin py4vb.ucPyDbg dbg 
      Height          =   10725
      Left            =   90
      TabIndex        =   0
      Top             =   90
      Width           =   12795
      _ExtentX        =   22569
      _ExtentY        =   18918
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'for my typical usage..when I want to use a debugger interface, I expect the debugger itself to handle
'just about everything for me in the ocx based interface. The only thing I need to do is load and save scripts
'and add host objects to the script engine.

Dim last As String

Private Sub dbg_ExecutionStarting()
    WriteFile last, dbg.Text 'in case we crash
End Sub

'do any addobject calls here...
Private Sub dbg_Initilized()

    Dim args() As String
    args = Split("arg1 arg2 arg3", " ")
    dbg.SetScriptArgs args
    
    dbg.AddObject Me, "host"
    
End Sub

Private Sub Form_Load()
    'dbg.IndentationGuides = True
    last = App.path & "\last_dbg.py"
    If FileExists(last) Then dbg.Text = ReadFile(last)
End Sub

'todo: add resize code within the ocx
'Private Sub Form_Resize()
'    On Error Resume Next
'    dbg.Width = Me.Width - 500
'    dbg.Height = Me.Height - 500
'End Sub

Private Sub Form_Unload(Cancel As Integer)

    If dbg.isRunning Then
        MsgBox "Stop execution first", vbExclamation
        'we need the usercontrol to call release timer on termination or process can hang with hidden form alive
        Cancel = 1
        Exit Sub
    End If
    
    WriteFile last, dbg.Text
    
End Sub


Function FileExists(path As String) As Boolean
  On Error GoTo hell
    
  If Len(path) = 0 Then Exit Function
  If Right(path, 1) = "\" Then Exit Function
  If Dir(path, vbHidden Or vbNormal Or vbReadOnly Or vbSystem) <> "" Then FileExists = True
  
  Exit Function
hell: FileExists = False
End Function

Function ReadFile(filename)
  Dim f, temp
  f = FreeFile
  temp = ""
   Open filename For Binary As #f        ' Open file.(can be text or image)
     temp = Input(FileLen(filename), #f) ' Get entire Files data
   Close #f
   ReadFile = temp
End Function


Sub WriteFile(path, it)
    Dim f
    f = FreeFile
    Open path For Output As #f
    Print #f, it
    Close f
End Sub

