import threading
import win32con, win32api, win32gui, ctypes, ctypes.wintypes, sys, struct
from array import array
import time
from datetime import datetime

# pip install pypiwin32

# this example comes from yokesee thanks!
# note we can not use print from sub threads because TLS isnt initilized for them and vb runtime will crash.
# we use the WM_COPYDATA IPC to sync with main vb thread through the window handler.

WM_DISPLAY_TEXT = 3

class COPYDATASTRUCT(ctypes.Structure):
    _fields_ = [
        ('dwData', ctypes.wintypes.LPARAM),
        ('cbData', ctypes.wintypes.DWORD),
        ('lpData', ctypes.c_void_p)
    ]
PCOPYDATASTRUCT = ctypes.POINTER(COPYDATASTRUCT)


def sendCommand(w, message):
    #print( "sending msg'%s' to %s" % (message, w))
    isWindow = win32gui.IsWindow(int(w))
    if isWindow != 1:
        #print( "not a valid hwnd")
        return
    CopyDataStruct = "IIP"
    char_buffer = array('b', map(ord, message))
    char_buffer_address = char_buffer.buffer_info()[0]
    char_buffer_size = char_buffer.buffer_info()[1]
    cds = struct.pack(CopyDataStruct, WM_DISPLAY_TEXT, char_buffer_size, char_buffer_address)
    v = win32gui.SendMessage(int(w), win32con.WM_COPYDATA, 0, cds)
    #print( "done retval = %d" % v) 
    
class thread(threading.Thread):
    def __init__(self, thread_name, thread_ID):
        threading.Thread.__init__(self)
        self.thread_name = thread_name
        self.thread_ID = thread_ID
 
        # helper function to execute the threads
    def run(self):
        global vb_hwnd, threads_complete
        sendCommand(vb_hwnd, str(self.thread_name) +" "+ str(self.thread_ID));
        threads_complete = threads_complete + 1


#vb_hwnd = 0 # we set this global from vb before running
threads_complete = 0

#this is from the main thread so print is ok..
print("vb_hwnd = " + str(vb_hwnd) + " time: " + str(datetime.now()))

thread1 = thread("GFG", 1000)
thread2 = thread("GeeksforGeeks", 2000);
 
thread1.start()
thread2.start()

while threads_complete != 2:
    emb.refresh()  # this was added new to call DoEvents
 
print("Threads are complete now!") 















