#ifndef __VB6_H__
#define __VB6_H__ 1
#ifdef  __cplusplus
extern "C" {
#endif

typedef enum{ 
	cb_output=0, 
	cb_error = 1,
	cb_Refresh = 2,
	cb_StringReturn = 3
} cb_type;

typedef enum {
	dcb_dbg = 0,
	dcb_callstack = 1,
	dcb_globals = 2,
	dcb_locals = 3,
	dcb_args = 4
} dcb_type;

//Public Sub vb_stdout(ByVal t As cb_type, ByVal lpMsg As Long)
typedef void (__stdcall *vbCallback)(cb_type, char*);

//Public Function GetDebuggerCommand(ByVal sz As dcb_type, ByVal lpMsg As Long ) As Long
typedef int (__stdcall *vbDbgCallback)(dcb_type, char*);

typedef int (__stdcall *vbHostResolverCallback)(char*, int, int, int); //*string, dukCtx, arg_cnt, hInst

extern vbCallback vbStdOut;
extern vbDbgCallback vbDbgOut;
extern vbDbgCallback vbDbgWriteHandler;
extern vbHostResolverCallback vbHostResolver;
extern vbDbgCallback vbLineInput;  


//we override these to force all outputs to the vb gui. not sure the internal hook thing
//catches all
/*
	#define	printf my_printf 
	#define	fprintf my_fprintf

	extern int my_printf(char* format, ...);
	extern int my_fprintf(FILE* fp, char* format, ...);
*/

#ifdef __cplusplus
}
#endif
#endif
