//v3.11
#define Py_LIMITED_API  0x030B0000
#include <windows.h>

#define PY_SSIZE_T_CLEAN
#include <Python.h>
#include <string>
#include <guiddef.h>

#define DECORATE "_"
#define MY_DLL_NAME "py4vb.dll"

#define EXPORT_FUNC(name) \
    __pragma(comment(linker, "/EXPORT:" DECORATE #name "=" MY_DLL_NAME  "." #name))

//these prototypes were manually extracted from web docs while reviewing the missing list, selected as most useful and wanted to make sure i had..
//auto gen output below

PyObject* __stdcall PyImport_ImportModule_(const char* name) {
    return PyImport_ImportModule(name);
}

PyObject* __stdcall PyImport_ImportModuleNoBlock_(const char* name) {
    return PyImport_ImportModuleNoBlock(name);
}

PyObject* __stdcall PyImport_ImportModuleEx_(const char* name, PyObject* globals, PyObject* locals, PyObject* fromlist) {
    return PyImport_ImportModuleEx(name, globals, locals, fromlist);
}

PyObject* __stdcall PyImport_ImportModuleLevelObject_(PyObject* name, PyObject* globals, PyObject* locals, PyObject* fromlist, int level) {
    return PyImport_ImportModuleLevelObject(name, globals, locals, fromlist, level);
}

PyObject* __stdcall PyImport_ImportModuleLevel_(const char* name, PyObject* globals, PyObject* locals, PyObject* fromlist, int level) {
    return PyImport_ImportModuleLevel(name, globals, locals, fromlist, level);
}

PyObject* __stdcall  PyImport_AddModuleObject_(PyObject* name) {
    return PyImport_AddModuleObject(name);
}

PyObject* __stdcall PyImport_AddModule_(const char* name) {
    return PyImport_AddModule(name);
}

PyObject* __stdcall PyImport_ExecCodeModule_(const char* name, PyObject* co) {
    return PyImport_ExecCodeModule(name, co);
}

PyObject* __stdcall PyImport_ExecCodeModuleEx_(const char* name, PyObject* co, const char* pathname) {
    return PyImport_ExecCodeModuleEx(name, co, pathname);
}

PyObject* __stdcall PyImport_ExecCodeModuleObject_(PyObject* name, PyObject* co, PyObject* pathname, PyObject* cpathname) {
    return PyImport_ExecCodeModuleObject(name, co, pathname, cpathname);
}

PyObject* __stdcall PyImport_ExecCodeModuleWithPathnames_(const char* name, PyObject* co, const char* pathname, const char* cpathname) {
    return PyImport_ExecCodeModuleWithPathnames(name, co, pathname, cpathname);
}

int __stdcall PyImport_ImportFrozenModuleObject_(PyObject* name) {
    return PyImport_ImportFrozenModuleObject(name);
}

int __stdcall PyImport_ImportFrozenModule_(const char* name) {
    return PyImport_ImportFrozenModule(name);
}

//int __stdcall PyImport_ExtendInittab_(struct _inittab* newtab) {
//    return PyImport_ExtendInittab( newtab)
//}

PyObject* __stdcall PyModule_New_(const char* name) {
    return PyModule_New(name);
}

PyObject* __stdcall PyModule_NewObject_(PyObject* name) {
    return PyModule_NewObject(name);
}

PyObject* __stdcall PyModule_FromDefAndSpec2_(PyModuleDef* def, PyObject* spec, int module_api_version) {
    return PyModule_FromDefAndSpec2(def, spec, module_api_version);
}

int __stdcall PyObject_AsCharBuffer_(PyObject* obj, const char** buffer, Py_ssize_t* buffer_len) {
    return PyObject_AsCharBuffer(obj, buffer, buffer_len);
}

int __stdcall PyObject_AsReadBuffer_(PyObject* obj, const void** buffer, Py_ssize_t* buffer_len) {
    return PyObject_AsReadBuffer(obj, buffer, buffer_len);
}

int __stdcall PyObject_CheckReadBuffer_(PyObject* o) {
    return PyObject_CheckReadBuffer(o);
}

int __stdcall PyObject_AsWriteBuffer_(PyObject* obj, void** buffer, Py_ssize_t* buffer_len) {
    return PyObject_AsWriteBuffer(obj, buffer, buffer_len);
}

//PyObject* __stdcall PyObject_CallFunction_(PyObject* callable, const char* format, ...) { //cant support variadic with stdcall requires array
//    return PyObject_CallFunction(callable, format, ...)
//}

//PyObject* __stdcall PyObject_CallFunctionObjArgs_(PyObject* callable, ..., NULL) {
//    return PyObject_CallFunctionObjArgs(callable, ..., NULL)
//}

//PyObject* __stdcall PyObject_CallMethod_(PyObject* o, const char* method, const char* format, ...) {
//   return PyObject_CallMethod(o, method, format, ...)
//}

//PyObject* __stdcall PyObject_CallMethodObjArgs_(PyObject* o, PyObject* name, ..., NULL) {
 //   return PyObject_CallMethodObjArgs(o, name, ..., NULL)
//}

//PyObject* __stdcall PyObject_CallMethod_(PyObject* o, const char* method, const char* format, ...) {
//    return PyObject_CallMethod(o, method, format, ...)
//}

PyObject* __stdcall PyObject_CallObject_(PyObject* callable_object, PyObject* args) {
    return PyObject_CallObject(callable_object, args);
}

PyObject*  __stdcall PyObject_Format_(PyObject* obj,PyObject* format_spec) {
    return PyObject_Format(obj, format_spec);
}

int __stdcall PyObject_GetBuffer_(PyObject* exporter, Py_buffer* view, int flags) {
    return PyObject_GetBuffer(exporter, view, flags);
}

PyObject* __stdcall PyUnicode_AsEncodedString_(PyObject* unicode, const char* encoding, const char* errors) {
    return PyUnicode_AsEncodedString(unicode, encoding, errors);
}

int __stdcall PyUnicode_Compare_(PyObject* left, PyObject* right) {
    return PyUnicode_Compare(left, right);
}

int __stdcall PyUnicode_CompareWithASCIIString_(PyObject* uni, const char* string) {
    return PyUnicode_CompareWithASCIIString(uni, string);
}

PyObject* __stdcall PyUnicode_Concat_(PyObject* left, PyObject* right) {
    return PyUnicode_Concat(left, right);
}

//Py_ssize_t __stdcall PyUnicode_Count_(PyObject* str, PyObject* substr, Py_ssize_t start, Py_ssize_t end) {
//    return  PyUnicode_Count(str, substr, start, end);
//}

//int __stdcall PyUnicode_Compare_(PyObject* left, PyObject* right) {
//    return PyUnicode_Compare(left, right);
//}

//int __stdcall PyUnicode_CompareWithASCIIString_(PyObject* uni, const char* string) {
//    return PyUnicode_CompareWithASCIIString(uni, string);
//}

int __stdcall PyUnicode_Contains_(PyObject* container, PyObject* element) {
    return PyUnicode_Contains(container, element);
}

PyObject* __stdcall PyUnicode_InternFromString_(const char* v) {
    return PyUnicode_InternFromString(v);
}

PyObject* __stdcall PyUnicode_Split_(PyObject* s, PyObject* sep, Py_ssize_t maxsplit) {
    return PyUnicode_Split(s, sep, maxsplit);
}

PyObject* __stdcall PyUnicode_Splitlines_(PyObject* s, int keepend) {
    return PyUnicode_Splitlines(s, keepend);
}

PyObject* __stdcall PyUnicode_Join_(PyObject* separator, PyObject* seq) {
    return PyUnicode_Join(separator, seq);
}

Py_ssize_t __stdcall PyUnicode_Tailmatch_(PyObject* str, PyObject* substr, Py_ssize_t start, Py_ssize_t end, int direction) {
    return  PyUnicode_Tailmatch(str, substr, start, end, direction);
}

Py_ssize_t __stdcall PyUnicode_Find_(PyObject* str, PyObject* substr, Py_ssize_t start, Py_ssize_t end, int direction) {
    return  PyUnicode_Find(str, substr, start, end, direction);
}

Py_ssize_t __stdcall PyUnicode_FindChar_(PyObject* str, Py_UCS4 ch, Py_ssize_t start, Py_ssize_t end, int direction) {
    return  PyUnicode_FindChar(str, ch, start, end, direction);
}

Py_ssize_t __stdcall PyUnicode_Count_(PyObject* str, PyObject* substr, Py_ssize_t start, Py_ssize_t end) {
    return  PyUnicode_Count(str, substr, start, end);
}

PyObject* __stdcall PyUnicode_Replace_(PyObject* str,  PyObject* substr, PyObject* replstr, Py_ssize_t maxcount) {
    return PyUnicode_Replace(str, substr, replstr, maxcount);
}

PyObject* __stdcall PyUnicode_RichCompare_(PyObject* left,  PyObject* right, int op) {
    return PyUnicode_RichCompare(left, right, op);
}

PyObject* __stdcall PyUnicode_Format_(PyObject* format,  PyObject* args) {
    return PyUnicode_Format(format, args);
}

//void __stdcall PyUnicode_InternInPlace_(PyObject** string) {
//    return  PyUnicode_InternInPlace(string);
//}

PyObject* __stdcall PyUnicode_Decode_(const char* s, Py_ssize_t size, const char* encoding, const char* errors) {
    return PyUnicode_Decode(s, size, encoding, errors);
}

PyObject* __stdcall PyUnicode_DecodeUTF8_(const char* s, Py_ssize_t size, const char* errors) {
    return PyUnicode_DecodeUTF8(s, size, errors);
}

PyObject* __stdcall PyUnicode_DecodeUTF8Stateful_(const char* s, Py_ssize_t size, const char* errors, Py_ssize_t* consumed) {
    return PyUnicode_DecodeUTF8Stateful(s, size, errors, consumed);
}

PyObject* __stdcall PyUnicode_DecodeUTF32Stateful_(const char* s, Py_ssize_t size, const char* errors, int* byteorder, Py_ssize_t* consumed) {
    return PyUnicode_DecodeUTF32Stateful(s, size, errors, byteorder, consumed);
}

PyObject* __stdcall PyUnicode_DecodeUTF32_(const char* s, Py_ssize_t size, const char* errors, int* byteorder) {
    return PyUnicode_DecodeUTF32(s, size, errors, byteorder);
}

PyObject* __stdcall PyUnicode_DecodeUTF16_(const char* s, Py_ssize_t size, const char* errors, int* byteorder) {
    return PyUnicode_DecodeUTF16(s, size, errors, byteorder);
}

PyObject* __stdcall PyUnicode_DecodeUTF16Stateful_(const char* s, Py_ssize_t size, const char* errors, int* byteorder, Py_ssize_t* consumed) {
    return PyUnicode_DecodeUTF16Stateful(s, size, errors, byteorder, consumed);
}

PyObject* __stdcall PyUnicode_DecodeRawUnicodeEscape_(const char* s, Py_ssize_t size, const char* errors) {
    return PyUnicode_DecodeRawUnicodeEscape(s, size, errors);
}

PyObject* __stdcall PyUnicode_DecodeLatin1_(const char* s, Py_ssize_t size, const char* errors) {
    return PyUnicode_DecodeLatin1(s, size, errors);
}

PyObject* __stdcall PyUnicode_DecodeASCII_(const char* s, Py_ssize_t size, const char* errors) {
    return PyUnicode_DecodeASCII(s, size, errors);
}

PyObject* __stdcall PyUnicode_DecodeCharmap_(const char* s, Py_ssize_t size, PyObject* mapping, const char* errors) {
    return PyUnicode_DecodeCharmap(s, size, mapping, errors);
}

PyObject* __stdcall PyUnicode_DecodeMBCS_(const char* s, Py_ssize_t size, const char* errors) {
    return PyUnicode_DecodeMBCS(s, size, errors);
}

PyObject* __stdcall PyUnicode_DecodeMBCSStateful_(const char* s, int size, const char* errors, int* consumed) {
    return PyUnicode_DecodeMBCSStateful(s, size, errors, consumed);
}

//manual2
PyObject* __stdcall PyUnicode_FromObject_(PyObject* obj) {
    return PyUnicode_FromObject(obj);
}

PyObject* __stdcall PyUnicode_FromString_(const char* u) {
    return PyUnicode_FromString(u);
}

PyObject* __stdcall  PyUnicode_FromStringAndSize_(const char* u, Py_ssize_t size) {
    return PyUnicode_FromStringAndSize(u, size);
}

//PyObject* __stdcall PyUnicode_FromFormat_(const char* format, ...) {
//    return PyUnicode_FromFormat(format, ...)
//}

PyObject* __stdcall PyUnicode_FromWideChar_(const wchar_t* w, Py_ssize_t size) {
    return PyUnicode_FromWideChar(w, size);
}

Py_ssize_t __stdcall PyUnicode_GetLength_(PyObject* unicode) {
    return  PyUnicode_GetLength(unicode);
}

Py_ssize_t __stdcall PyUnicode_GetSize_(PyObject* unicode) {
    return  PyUnicode_GetSize(unicode);
}

Py_UCS4 __stdcall PyUnicode_ReadChar_(PyObject* unicode, Py_ssize_t index) {
    return PyUnicode_ReadChar(unicode, index);
}

PyObject* __stdcall PyUnicode_Substring_(PyObject* str,  Py_ssize_t start, Py_ssize_t end) {
    return PyUnicode_Substring(str, start, end);
}

//PyObject* __stdcall PyUnicode_Splitlines_(PyObject* s, int keepend) {
//    return PyUnicode_Splitlines(s, keepend);
//}

PyObject* __stdcall  PyUnicode_AsASCIIString_(PyObject* unicode) {
    return PyUnicode_AsASCIIString(unicode);
}

//PyObject* __stdcall  PyUnicode_AsEncodedString_(PyObject* unicode, const char* encoding, const char* errors) {
//    return PyUnicode_AsEncodedString(unicode, encoding, errors);
//}

PyObject* __stdcall  PyUnicode_AsMBCSString_(PyObject* unicode) {
    return PyUnicode_AsMBCSString(unicode);
}

Py_ssize_t __stdcall PyUnicode_AsWideChar_(PyObject* unicode, wchar_t* w, Py_ssize_t size) {
    return  PyUnicode_AsWideChar(unicode, w, size);
}

wchar_t* __stdcall PyUnicode_AsWideCharString_(PyObject* unicode,  Py_ssize_t* size) {
    return  PyUnicode_AsWideCharString(unicode, size);
}

PyObject* __stdcall PyUnicode_AsUnicodeEscapeString_(PyObject* unicode) {
    return PyUnicode_AsUnicodeEscapeString(unicode);
}

PyObject* __stdcall PyUnicode_AsUTF8String_(PyObject* unicode) {
    return PyUnicode_AsUTF8String(unicode);
}

const char* __stdcall PyUnicode_AsUTF8AndSize_(PyObject* unicode, Py_ssize_t* size) {
    return PyUnicode_AsUTF8AndSize(unicode, size);
}


EXPORT_FUNC(*PyImport_ImportModule_)
EXPORT_FUNC(*PyImport_ImportModuleNoBlock_)
EXPORT_FUNC(*PyImport_ImportModuleEx_)
EXPORT_FUNC(*PyImport_ImportModuleLevelObject_)
EXPORT_FUNC(*PyImport_ImportModuleLevel_)
EXPORT_FUNC(*PyImport_AddModuleObject_)
EXPORT_FUNC(*PyImport_AddModule_)
EXPORT_FUNC(*PyImport_ExecCodeModule_)
EXPORT_FUNC(*PyImport_ExecCodeModuleEx_)
EXPORT_FUNC(*PyImport_ExecCodeModuleObject_)
EXPORT_FUNC(*PyImport_ExecCodeModuleWithPathnames_)
EXPORT_FUNC(PyImport_ImportFrozenModuleObject_)
EXPORT_FUNC(PyImport_ImportFrozenModule_)
//EXPORT_FUNC(PyImport_ExtendInittab_)
EXPORT_FUNC(*PyModule_New_)
EXPORT_FUNC(*PyModule_NewObject_)
EXPORT_FUNC(*PyModule_FromDefAndSpec2_)
EXPORT_FUNC(PyObject_AsCharBuffer_)
EXPORT_FUNC(PyObject_AsReadBuffer_)
EXPORT_FUNC(PyObject_CheckReadBuffer_)
EXPORT_FUNC(PyObject_AsWriteBuffer_)
//EXPORT_FUNC(PyObject_CallFunction_)
//EXPORT_FUNC(PyObject_CallFunctionObjArgs_)
//EXPORT_FUNC(PyObject_CallMethod_)
//EXPORT_FUNC(PyObject_CallMethodObjArgs_)
//EXPORT_FUNC(PyObject_CallMethod_)
EXPORT_FUNC(PyObject_CallObject_)
EXPORT_FUNC(*PyObject_Format_)
EXPORT_FUNC(PyObject_GetBuffer_)
EXPORT_FUNC(*PyUnicode_AsEncodedString_)
//EXPORT_FUNC(PyUnicode_Compare_)
//EXPORT_FUNC(PyUnicode_CompareWithASCIIString_)
EXPORT_FUNC(*PyUnicode_Concat_)
//EXPORT_FUNC(PyUnicode_Count_)
EXPORT_FUNC(PyUnicode_Compare_)
EXPORT_FUNC(PyUnicode_CompareWithASCIIString_)
EXPORT_FUNC(PyUnicode_Contains_)
EXPORT_FUNC(*PyUnicode_InternFromString_)
EXPORT_FUNC(*PyUnicode_Split_)
EXPORT_FUNC(*PyUnicode_Splitlines_)
EXPORT_FUNC(*PyUnicode_Join_)
EXPORT_FUNC(PyUnicode_Tailmatch_)
EXPORT_FUNC(PyUnicode_Find_)
EXPORT_FUNC(PyUnicode_FindChar_)
EXPORT_FUNC(PyUnicode_Count_)
EXPORT_FUNC(*PyUnicode_Replace_)
EXPORT_FUNC(*PyUnicode_RichCompare_)
EXPORT_FUNC(*PyUnicode_Format_)
//EXPORT_FUNC(PyUnicode_InternInPlace_)
EXPORT_FUNC(PyUnicode_Decode_)
EXPORT_FUNC(PyUnicode_DecodeUTF8_)
EXPORT_FUNC(PyUnicode_DecodeUTF8Stateful_)
EXPORT_FUNC(PyUnicode_DecodeUTF32Stateful_)
EXPORT_FUNC(PyUnicode_DecodeUTF32_)
EXPORT_FUNC(PyUnicode_DecodeUTF16_)
EXPORT_FUNC(PyUnicode_DecodeUTF16Stateful_)
EXPORT_FUNC(PyUnicode_DecodeRawUnicodeEscape_)
EXPORT_FUNC(PyUnicode_DecodeLatin1_)
EXPORT_FUNC(PyUnicode_DecodeASCII_)
EXPORT_FUNC(PyUnicode_DecodeCharmap_)
EXPORT_FUNC(PyUnicode_DecodeMBCS_)
EXPORT_FUNC(PyUnicode_DecodeMBCSStateful_)

//manual 2
EXPORT_FUNC(*PyUnicode_FromObject_)
EXPORT_FUNC(*PyUnicode_FromString_)
EXPORT_FUNC(*PyUnicode_FromStringAndSize_)
//EXPORT_FUNC(*PyUnicode_FromFormat_)
EXPORT_FUNC(*PyUnicode_FromWideChar_)
EXPORT_FUNC(PyUnicode_GetLength_)
EXPORT_FUNC(PyUnicode_GetSize_)
EXPORT_FUNC(PyUnicode_ReadChar_)
EXPORT_FUNC(*PyUnicode_Substring_)
//EXPORT_FUNC(*PyUnicode_Splitlines_)
EXPORT_FUNC(*PyUnicode_AsASCIIString_)
//EXPORT_FUNC(*PyUnicode_AsEncodedString_)
EXPORT_FUNC(*PyUnicode_AsMBCSString_)
EXPORT_FUNC(PyUnicode_AsWideChar_)
EXPORT_FUNC(*PyUnicode_AsWideCharString_)
EXPORT_FUNC(*PyUnicode_AsUnicodeEscapeString_)
EXPORT_FUNC(*PyUnicode_AsUTF8String_)
EXPORT_FUNC(*PyUnicode_AsUTF8AndSize_)